//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <math.h>
#include "SMP_CTask.h"
#include "SMP_Test.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
void __fastcall TSMP_CThread::Execute(void)
{
	int i;
	int NBUF,NY;
	const int NX=1024;
  volatile unsigned char *buf;
	volatile register double r1;
	int *Histogram;
	const int OType=SMPTest->Operation->ItemIndex;

	switch (SMPTest->MemorySize->ItemIndex) {
		case 0: NY=128; break;
		case 1: NY=256; break;
		case 2: NY=512; break;
		case 3: NY=1024; break;
		case 4: NY=2048; break;
		case 5: NY=4096; break;
		default: NY=128;
	}

	NBUF=NY*NX;
	buf=new unsigned char [NBUF];
	for (i=0;i<NBUF;i++) buf[i]=(unsigned char)i;
	Histogram=new int [256];
	t0=GetTickCount();

	while (!Terminated) {
		switch (OType) {
			case 0:
				for (i=0;i<NY;i++)
				r1=sin(0.025*i);
				break;
			case 1:
				for (i=0;i<NBUF;i++)
				if (buf[i]);
				break;
			case 2:
				for (i=0;i<NBUF;i++)
				buf[i]=(unsigned char)i;
				break;
			case 3:
				for (i=0;i<NBUF;i++)
				buf[i]++;
				break;
			case 4:
				for (i=0;i<256;i++)
				Histogram[i]=0;
				for (i=0;i<NBUF;i++)
				Histogram[buf[i]]++;
				break;
			case 5:
				for (i=0;i<NBUF;i++)
				if (buf[i]>128) buf[i]=255;
				else buf[i]=0;
				break;
		}
		NR++;
		t1=GetTickCount();
		dt=t1-t0;
		if (dt<0) {
			dt=0;
			t0=t1;
			NR=0;
		}
		if (dt>=1000) {
			t0=t1;
			NumRun=NR;
			NR=0;
			if (SMPTest->Operation->ItemIndex!=0) BytesPerSecond=NumRun*NBUF;
		}
	}

	delete[] Histogram;
	delete[] buf;
}
//---------------------------------------------------------------------------
__fastcall TSMP_CThread::TSMP_CThread(void)
	:TThread(true)
{
	FreeOnTerminate=false;
}
